import 'dart:async';
import 'dart:io';
import 'package:build/build.dart';
import 'package:string_case_converter/string_case_converter.dart';
import 'package:yaml/yaml.dart';
import 'utils.dart';

class FontFamiliesBuilder implements Builder {
  FontFamiliesBuilder(BuilderOptions options);

  final String _fontClassName = "AppFonts";

  @override
  FutureOr<void> build(BuildStep? buildStep) async {
    File f = File("./pubspec.yaml");
    var text = await f.readAsString();
    Map yaml = loadYaml(text);
    if (yaml['flutter']['fonts'] != null &&
        yaml['flutter']['fonts'].isNotEmpty) {
      Map<dynamic, dynamic> fonts = {_fontClassName: {}};
      for (var font in yaml['flutter']['fonts']) {
        fonts[_fontClassName][(font['family']).toCamelCase()] = font['family'];
      }
      filePutContents((_fontClassName).toSnakeCase(), fonts);
    }
  }

  @override
  Map<String, List<String>> get buildExtensions => {
        ".yaml": [genFileSuffix],
        ".ttf": [genFileSuffix],
        ".otf": [genFileSuffix],
        "${(_fontClassName).toSnakeCase()}$genFileSuffix": [genFileSuffix],
      };
}
